package  {
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.PNGEncoderOptions;
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.net.FileReference;
	import flash.utils.ByteArray;
	import ru.volgogradetzzz.math.VMatrix4x4;
	import ru.volgogradetzzz.math.VVector3;
	
	/**
	 * ...
	 * @author Volgogradetzzz
	 */
	public class DepthMapCreator extends Sprite {
		
		private const _ANG:Number = 30 * Math.PI / 180;
		private const _W:Number = 49;
		private const _H:Number = 49;
		private const _D:Number = 49;
		
		private var _bds:Vector.<BitmapData> = new Vector.<BitmapData>();
		
		public function DepthMapCreator() {
			// triangle 1
			var t1:Triangle = new Triangle();
			
			var pos:VVector3 = new VVector3(0, 1, 0);
			var v:Vertex = new Vertex();
			v.pos = pos;
			computeVertexColor(v);
			t1.v1 = v;
			
			pos = new VVector3(0, 1, 1);
			v = new Vertex();
			v.pos = pos;
			computeVertexColor(v);
			t1.v2 = v;
			
			pos = new VVector3(1, 1, 1);
			v = new Vertex();
			v.pos = pos;
			computeVertexColor(v);
			t1.v3 = v;
			
			_bds.push(rasterizeTriangle(t1));
			
			// triangle 2
			var t2:Triangle = new Triangle();
			
			pos = new VVector3(0, 1, 0);
			v = new Vertex();
			v.pos = pos;
			computeVertexColor(v);
			t2.v1 = v;
			
			pos = new VVector3(1, 1, 1);
			v = new Vertex();
			v.pos = pos;
			computeVertexColor(v);
			t2.v2 = v;
			
			pos = new VVector3(1, 1, 0);
			v = new Vertex();
			v.pos = pos;
			computeVertexColor(v);
			t2.v3 = v;
			
			_bds.push(rasterizeTriangle(t2));
			
			// triangle 3
			var t3:Triangle = new Triangle();
			
			pos = new VVector3(0, 0, 1);
			v = new Vertex();
			v.pos = pos;
			computeVertexColor(v);
			t3.v1 = v;
			
			pos = new VVector3(1, 1, 1);
			v = new Vertex();
			v.pos = pos;
			computeVertexColor(v);
			t3.v2 = v;
			
			pos = new VVector3(0, 1, 1);
			v = new Vertex();
			v.pos = pos;
			computeVertexColor(v);
			t3.v3 = v;
			
			_bds.push(rasterizeTriangle(t3));
			
			// triangle 4
			var t4:Triangle = new Triangle();
			
			pos = new VVector3(0, 0, 1);
			v = new Vertex();
			v.pos = pos;
			computeVertexColor(v);
			t4.v1 = v;
			
			pos = new VVector3(1, 0, 1);
			v = new Vertex();
			v.pos = pos;
			computeVertexColor(v);
			t4.v2 = v;
			
			pos = new VVector3(1, 1, 1);
			v = new Vertex();
			v.pos = pos;
			computeVertexColor(v);
			t4.v3 = v;
			
			_bds.push(rasterizeTriangle(t4));
			
			// triangle 5
			/*var t5:Triangle = new Triangle();
			
			pos = new VVector3(0, 0.5, 1);
			v = new Vertex();
			v.pos = pos;
			computeVertexColor(v);
			t5.v1 = v;
			
			pos = new VVector3(0.5, 0, 1);
			v = new Vertex();
			v.pos = pos;
			computeVertexColor(v);
			t5.v2 = v;
			
			pos = new VVector3(1, 0.5, 1);
			v = new Vertex();
			v.pos = pos;
			computeVertexColor(v);
			t5.v3 = v;
			
			_bds.push(rasterizeTriangle(t5));
			
			// triangle 6
			var t6:Triangle = new Triangle();
			
			pos = new VVector3(0, 0.5, 1);
			v = new Vertex();
			v.pos = pos;
			computeVertexColor(v);
			t6.v1 = v;
			
			pos = new VVector3(1, 0.5, 1);
			v = new Vertex();
			v.pos = pos;
			computeVertexColor(v);
			t6.v2 = v;
			
			pos = new VVector3(0.5, 1, 1);
			v = new Vertex();
			v.pos = pos;
			computeVertexColor(v);
			t6.v3 = v;
			
			_bds.push(rasterizeTriangle(t6));*/
			
			merge();
		}
		
		private function computeVertexColor(v:Vertex):void {
			var normal:VVector3 = new VVector3(0, 1, 0);
			var m:VMatrix4x4 = new VMatrix4x4();
			m.setupRotation(_ANG, 0, 0);
			
			normal.multiplyByMatrix(m);
			
			var diag:VVector3 = new VVector3(0, _D, _H);
			var maxProj:Number = diag.dot(normal);
			
			var temp:VVector3 = new VVector3(0, _D * v.pos.y, _H * v.pos.z);
			var proj:Number = temp.dot(normal);
			
			proj /= maxProj;
			
			v.depth = proj;
		}
		
		private function rasterizeTriangle(t:Triangle):BitmapData {
			var trueH:uint = _H + Math.ceil(_D * Math.sin(_ANG));
			var bd:BitmapData = new BitmapData(_W + 1, trueH + 1, true, 0x00000000);
			
			var pos:VVector3 = t.v1.pos;
			var p1:Point = new Point();
			p1.x = _W * pos.x;
			p1.y = _H + _D * pos.y * Math.sin(_ANG) - _H * pos.z;
			
			pos = t.v2.pos;
			var p2:Point = new Point();
			p2.x = _W * pos.x;
			p2.y = _H + _D * pos.y * Math.sin(_ANG) - _H * pos.z;
			
			pos = t.v3.pos;
			var p3:Point = new Point();
			p3.x = _W * pos.x;
			p3.y = _H + _D * pos.y * Math.sin(_ANG) - _H * pos.z;
			
			TriangleRasterizer.rasterizeTriangle(p1, p2, p3, t.v1.depth, t.v2.depth, t.v3.depth, bd);
			
			return bd;
		}
		
		private function merge():void {
			var trueH:uint = _H + Math.ceil(_D * Math.sin(_ANG));
			var finalBD:BitmapData = new BitmapData(_W + 1, trueH + 1, true, 0x00000000);
			
			var bufferColor:uint;
			var bufferAlpha:uint;
			var bufferDepth:Number
			
			var color:uint;
			var a:uint;
			var d:Number;
			
			for each(var bd:BitmapData in _bds) {
				for (var pixY:uint = 0; pixY < bd.height; pixY++) {
					for (var pixX:uint = 0; pixX < bd.width; pixX++) {
						color = bd.getPixel32(pixX, pixY);
						a = (color >> 24) & 0xFF;
						
						if (a > 0) {
							bufferColor = finalBD.getPixel32(pixX, pixY);
							bufferAlpha = (bufferColor >> 24) & 0xFF;
							d = FloatColorConverter.color24ToUnitFloat(color);
							
							if (bufferAlpha > 0) {
								bufferDepth = FloatColorConverter.color24ToUnitFloat(bufferColor);
								d = FloatColorConverter.color24ToUnitFloat(color);
								
								if ( d > bufferDepth) {
									finalBD.setPixel32(pixX, pixY, color);
								}
							}else {
								finalBD.setPixel32(pixX, pixY, color);
							}
							
						}
					}
				}
			}
			
			addChild(new Bitmap(finalBD));
			
			var ba:ByteArray = finalBD.encode(finalBD.rect, new PNGEncoderOptions());
			var fileReference:FileReference = new FileReference();
			fileReference.save(ba, 'pic.png');
		}
	}
}
import ru.volgogradetzzz.math.VVector3;

internal class Triangle {
	public var v1:Vertex = new Vertex();
	public var v2:Vertex = new Vertex();
	public var v3:Vertex = new Vertex();
}

internal class Vertex {
	public var pos:VVector3 = new VVector3();
	public var depth:Number = 0;
}